/******************************************************************************

Coral Tree dna/error.cc
Copyright (C) 1998 Infinite Monkeys Incorporated

This program is free software; you can redistribute it and/or modify
it under the terms of the Artistic License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Artistic License for more details.

You should have received a copy of the Artistic License along with
this program (see meta/ART_LICE); if not, write to coral@imonk.com.

******************************************************************************/

#include <dna/dna.h>

/******************************************************************************
enum DNA_ErrorType
******************************************************************************/
/***********************************************************************
const char *dnaErrorTypeToString(const DNA_ErrorType t)
***********************************************************************/
const char *dnaErrorTypeToString(const DNA_ErrorType t)
{
	switch (t)
	{
	case DNA_ERROR_NONE: return "DNA_ERROR_NONE";
	case DNA_ERROR_INSUFFICIENT_MEMORY: return "DNA_ERROR_INSUFFICIENT_MEMORY";
	case DNA_ERROR_NO_DATA_AVAILABLE: return "DNA_ERROR_NO_DATA_AVAILABLE";
	case DNA_ERROR_BAD_HANDLE: return "DNA_ERROR_BAD_HANDLE";
	case DNA_ERROR_BAD_MESSAGE: return "DNA_ERROR_BAD_MESSAGE";
	case DNA_ERROR_BAD_ADDRESS: return "DNA_ERROR_BAD_ADDRESS";
	case DNA_ERROR_INTERRUPTED_CALL: return "DNA_ERROR_INTERRUPTED_CALL";
	case DNA_ERROR_IO_ERROR: return "DNA_ERROR_IO_ERROR";
	case DNA_ERROR_BAD_IMPLEMENTATION: return "DNA_ERROR_BAD_IMPLEMENTATION";
	case DNA_ERROR_BAD_STATE: return "DNA_ERROR_BAD_STATE";
	case DNA_ERROR_INSUFFICIENT_RESOURCE: return "DNA_ERROR_INSUFFICIENT_RESOURCE";
	case DNA_ERROR_BAD_PROTOCOL: return "DNA_ERROR_BAD_PROTOCOL";
	case DNA_ERROR_NO_PERMISSION: return "DNA_ERROR_NO_PERMISSION";
	case DNA_ERROR_ADDRESS_IN_USE: return "DNA_ERROR_ADDRESS_IN_USE";
	case DNA_ERROR_ADDRESS_UNAVAILABLE: return "DNA_ERROR_ADDRESS_UNAVAILABLE";
	case DNA_ERROR_PROTOCOL_ERROR: return "DNA_ERROR_PROTOCOL_ERROR";
	case DNA_ERROR_BLOCK_IMPENDING: return "DNA_ERROR_BLOCK_IMPENDING";
	case DNA_ERROR_BAD_FAMILY: return "DNA_ERROR_BAD_FAMILY";
	case DNA_ERROR_CONNECTION_IMPENDING: return "DNA_ERROR_CONNECTION_IMPENDING";
	case DNA_ERROR_CONNECTION_REFUSED: return "DNA_ERROR_CONNECTION_REFUSED";
	case DNA_ERROR_CONNECTION_PENDING: return "DNA_ERROR_CONNECTION_PENDING";
	case DNA_ERROR_HANDLE_CONNECTED: return "DNA_ERROR_HANDLE_CONNECTED";
	case DNA_ERROR_NETWORK_UNREACHABLE: return "DNA_ERROR_NETWORK_UNREACHABLE";
	case DNA_ERROR_TIME_OUT: return "DNA_ERROR_TIME_OUT";
	case DNA_ERROR_CONNECTION_RESET: return "DNA_ERROR_CONNECTION_RESET";
	default: return "UNKNOWN";
	}
}

/******************************************************************************
class DNA_Error
******************************************************************************/
/***********************************************************************
GPL_String DNA_Error::ToString(void) const
***********************************************************************/
GPL_String DNA_Error::ToString(void) const
{
	GPL_String image;
	register char *c = comment.GetData();
	if ((char *) 0 == c)
	{
		image.Printf("%s(%X)", dnaErrorTypeToString(type), code);
	}
	else
	{
		image.Printf("%s(%X): %s", dnaErrorTypeToString(type), code, c);
	}
	return image;
}
