
/******************************************************************************

Coral Tree dna/handler.cc
Copyright (C) 1998 Infinite Monkeys Incorporated

This program is free software; you can redistribute it and/or modify
it under the terms of the Artistic License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
Artistic License for more details.

You should have received a copy of the Artistic License along with
this program (see meta/ART_LICE); if not, write to coral@imonk.com.

******************************************************************************/

#include <wba/wba.h>
#include <dna/message.h>
#include <dna/handler.h>

/******************************************************************************
class DNA_MessageHandler
******************************************************************************/

/******************************************************************************
GPL_Boolean DNA_MessageHandler::HandleMessage(DNA_Message & message)
******************************************************************************/
GPL_Boolean DNA_MessageHandler::HandleMessage(DNA_Message & message,
									GPL_Boolean & consumedMessage)
{
	consumedMessage = FALSE;
	return TRUE;
}

/******************************************************************************
class DNA_MessageHandlerWithTimeout
******************************************************************************/

/******************************************************************************
DNA_MessageHandlerWithTimeout::DNA_MessageHandlerWithTimeout(const unsigned long milliseconds)
******************************************************************************/
DNA_MessageHandlerWithTimeout::DNA_MessageHandlerWithTimeout(const unsigned long milliseconds)
{
fprintf(stderr,"DNA_MessageHandlerWithTimeout::DNA_MessageHandlerWithTimeout\n");
	inceptionTime.GetFromClock();
	real64 seconds = (real64) milliseconds / 1000.0;
	interval.ConvertFromSeconds(seconds);
}

/******************************************************************************
GPL_Boolean DNA_MessageHandlerWithTimeout::GetExpired(void)
******************************************************************************/
GPL_Boolean DNA_MessageHandlerWithTimeout::GetExpired(void)
{
	if (!hasExpired)
	{
fprintf(stderr,"DNA_MessageHandlerWithTimeout::GetExpired\n");
		const GPL_Time elapsedTime = gplCurrentTime() - inceptionTime;
		hasExpired = (elapsedTime >= interval);
	}
	return hasExpired;
}

